"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCloudOptions = void 0;
const fs_1 = require("fs");
const { workspaceRoot } = require('./nx-imports-light');
// This package is ESM and needs to be imported using an async import
// IF YOU CHANGE THIS, THE PACKAGE WILL FAIL TO LOAD AT RUNTIME
// YOU WILL NOT CATCH IT IN CI
const dynamicImport = new Function('specifier', 'return import(specifier)');
let stripJsonComments;
(function () {
    return __awaiter(this, void 0, void 0, function* () {
        stripJsonComments = (yield dynamicImport('strip-json-comments')).default;
    });
})();
function getCloudOptions(taskRunnerConfiguration) {
    var _a, _b, _c, _d, _e, _f, _g, _h;
    const nxJson = JSON.parse(stripJsonComments((0, fs_1.readFileSync)(`${workspaceRoot}/nx.json`).toString(), {
        trailingCommas: true,
    }));
    const result = {};
    const defaultCacheableOperations = [];
    for (const key in nxJson.targetDefaults) {
        if (nxJson.targetDefaults[key].cache) {
            defaultCacheableOperations.push(key);
        }
    }
    if (nxJson.nxCloudAccessToken) {
        (_a = result.accessToken) !== null && _a !== void 0 ? _a : (result.accessToken = nxJson.nxCloudAccessToken);
    }
    if (nxJson.nxCloudId) {
        (_b = result.nxCloudId) !== null && _b !== void 0 ? _b : (result.nxCloudId = nxJson.nxCloudId);
    }
    if (nxJson.nxCloudUrl) {
        (_c = result.url) !== null && _c !== void 0 ? _c : (result.url = nxJson.nxCloudUrl);
    }
    if (nxJson.nxCloudEncryptionKey) {
        result.encryptionKey = nxJson.nxCloudEncryptionKey;
    }
    if (nxJson.parallel) {
        (_d = result.parallel) !== null && _d !== void 0 ? _d : (result.parallel = nxJson.parallel);
    }
    if (nxJson.cacheDirectory) {
        (_e = result.cacheDirectory) !== null && _e !== void 0 ? _e : (result.cacheDirectory = nxJson.cacheDirectory);
    }
    if (defaultCacheableOperations.length) {
        (_f = result.cacheableOperations) !== null && _f !== void 0 ? _f : (result.cacheableOperations = defaultCacheableOperations);
    }
    return {
        nxJson,
        nxCloudOptions: Object.assign(Object.assign({}, result), (_h = (_g = nxJson.tasksRunnerOptions) === null || _g === void 0 ? void 0 : _g[taskRunnerConfiguration]) === null || _h === void 0 ? void 0 : _h.options),
    };
}
exports.getCloudOptions = getCloudOptions;
//# sourceMappingURL=get-cloud-options.js.map